######################################################################
#
# EPrints::Plugin
#
######################################################################
#
#  This file is part of GNU EPrints 2.
#  
#  Copyright (c) 2000-2004 University of Southampton, UK. SO17 1BJ.
#  
#  EPrints 2 is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#  
#  EPrints 2 is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#  
#  You should have received a copy of the GNU General Public License
#  along with EPrints 2; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
######################################################################


=pod

=head1 NAME

B<EPrints::Plugin> - undocumented

=head1 DESCRIPTION

undocumented

=over 4

=cut

package EPrints::Plugin;

use strict;

######################################################################
=pod

=item $plugin = EPrints::Plugin->new( $params, $session )

undocumented

=cut
######################################################################

sub new
{
	my( $class, $params, $session ) = @_;

	my $self = EPrints::Utils::clone( $params );

	if( defined $params->{parent} )
	{
		my $parent = $session->plugin( $params->{parent} );

		foreach my $key ( keys %{$parent} )
		{
			next if defined $self->{$key};
			$self->{$key} = $parent->{$key};
		}
	}
	$self->{session} = $session;

	bless $self, $class;

	return $self;
}


######################################################################
=pod

=item $thing = $plugin->call( $methodid, @params )

Calls the named method of this plugin, passing the parameters and
returning what the method returns.

=cut
######################################################################

sub call
{
	my( $self, $methodid, @params ) = @_;

	my $method = $self->{$methodid};

	if( !defined $method )
	{
		# cjg bad warning code
		print STDERR "Unknown method on plugin ".$self->{id}.": $methodid\n";
		return undef;
	}

	return &{$method}( $self, @params );
}

1;

######################################################################
=pod

=back

=cut
######################################################################

